/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.geronimo.jee.openejb;

import javax.xml.bind.JAXBElement;
import javax.xml.bind.annotation.XmlElementDecl;
import javax.xml.bind.annotation.XmlRegistry;
import javax.xml.namespace.QName;


/**
 * This object contains factory methods for each 
 * Java content interface and Java element interface 
 * generated in the org.apache.openejb.xml.ns.openejb_jar_2 package. 
 * <p>An ObjectFactory allows you to programatically 
 * construct new instances of the Java representation 
 * for XML content. The Java representation of XML 
 * content can consist of schema derived interfaces 
 * and classes representing the binding of schema 
 * type definitions, element declarations and model 
 * groups.  Factory methods for each of these are 
 * provided in this class.
 * 
 * @version $Rev: 650704 $ $Date: 2008-04-23 08:09:15 +0800 (Wed, 23 Apr 2008) $
 */
@XmlRegistry
public class ObjectFactory {

    private final static QName _OpenejbJar_QNAME = new QName("http://openejb.apache.org/xml/ns/openejb-jar-2.2", "openejb-jar");

    /**
     * Create a new ObjectFactory that can be used to create new instances of schema derived classes for package: org.apache.openejb.xml.ns.openejb_jar_2
     * 
     */
    public ObjectFactory() {
    }

    /**
     * Create an instance of {@link EntityBean.CmpFieldMapping }
     * 
     */
    public EntityBean.CmpFieldMapping createEntityBeanCmpFieldMapping() {
        return new EntityBean.CmpFieldMapping();
    }

    /**
     * Create an instance of {@link EjbRelation}
     * 
     */
    public EjbRelation createEjbRelation() {
        return new EjbRelation();
    }

    /**
     * Create an instance of {@link WebServiceSecurity}
     * 
     */
    public WebServiceSecurity createWebServiceSecurity() {
        return new WebServiceSecurity();
    }

    /**
     * Create an instance of {@link Group}
     * 
     */
    public Group createGroup() {
        return new Group();
    }

    /**
     * Create an instance of {@link EjbRelationshipRole}
     * 
     */
    public EjbRelationshipRole createEjbRelationshipRole() {
        return new EjbRelationshipRole();
    }

    /**
     * Create an instance of {@link Empty}
     * 
     */
    public Empty createEmpty() {
        return new Empty();
    }

    /**
     * Create an instance of {@link Query.QueryMethod.MethodParams }
     * 
     */
    public Query.QueryMethod.MethodParams createQueryQueryMethodMethodParams() {
        return new Query.QueryMethod.MethodParams();
    }

    /**
     * Create an instance of {@link EjbRelationshipRole.RoleMapping }
     * 
     */
    public EjbRelationshipRole.RoleMapping createEjbRelationshipRoleRoleMapping() {
        return new EjbRelationshipRole.RoleMapping();
    }

    /**
     * Create an instance of {@link OpenejbJar.EnterpriseBeans }
     * 
     */
    public OpenejbJar.EnterpriseBeans createOpenejbJarEnterpriseBeans() {
        return new OpenejbJar.EnterpriseBeans();
    }

    /**
     * Create an instance of {@link EntityBean.PrefetchGroup }
     * 
     */
    public EntityBean.PrefetchGroup createEntityBeanPrefetchGroup() {
        return new EntityBean.PrefetchGroup();
    }

    /**
     * Create an instance of {@link EjbRelationshipRole.RoleMapping.CmrFieldMapping 
     * } 
     * 
     */
    public EjbRelationshipRole.RoleMapping.CmrFieldMapping createEjbRelationshipRoleRoleMappingCmrFieldMapping() {
        return new EjbRelationshipRole.RoleMapping.CmrFieldMapping();
    }

    /**
     * Create an instance of {@link ActivationConfig}
     * 
     */
    public ActivationConfig createActivationConfig() {
        return new ActivationConfig();
    }

    /**
     * Create an instance of {@link Query}
     * 
     */
    public Query createQuery() {
        return new Query();
    }

    /**
     * Create an instance of {@link EntityBean.Cache }
     * 
     */
    public EntityBean.Cache createEntityBeanCache() {
        return new EntityBean.Cache();
    }

    /**
     * Create an instance of {@link EntityGroupMapping}
     * 
     */
    public EntityGroupMapping createEntityGroupMapping() {
        return new EntityGroupMapping();
    }

    /**
     * Create an instance of {@link OpenejbJar}
     * 
     */
    public OpenejbJar createOpenejbJar() {
        return new OpenejbJar();
    }

    /**
     * Create an instance of {@link CmrFieldGroupMapping}
     * 
     */
    public CmrFieldGroupMapping createCmrFieldGroupMapping() {
        return new CmrFieldGroupMapping();
    }

    /**
     * Create an instance of {@link EjbRelationshipRole.RelationshipRoleSource }
     * 
     */
    public EjbRelationshipRole.RelationshipRoleSource createEjbRelationshipRoleRelationshipRoleSource() {
        return new EjbRelationshipRole.RelationshipRoleSource();
    }

    /**
     * Create an instance of {@link Query.QueryMethod }
     * 
     */
    public Query.QueryMethod createQueryQueryMethod() {
        return new Query.QueryMethod();
    }

    /**
     * Create an instance of {@link CmpFieldGroupMapping}
     * 
     */
    public CmpFieldGroupMapping createCmpFieldGroupMapping() {
        return new CmpFieldGroupMapping();
    }

    /**
     * Create an instance of {@link SessionBean}
     * 
     */
    public SessionBean createSessionBean() {
        return new SessionBean();
    }

    /**
     * Create an instance of {@link EjbRelationshipRole.CmrField }
     * 
     */
    public EjbRelationshipRole.CmrField createEjbRelationshipRoleCmrField() {
        return new EjbRelationshipRole.CmrField();
    }

    /**
     * Create an instance of {@link EntityBean}
     * 
     */
    public EntityBean createEntityBean() {
        return new EntityBean();
    }

    /**
     * Create an instance of {@link Group.CmrField }
     * 
     */
    public Group.CmrField createGroupCmrField() {
        return new Group.CmrField();
    }

    /**
     * Create an instance of {@link MessageDrivenBean}
     * 
     */
    public MessageDrivenBean createMessageDrivenBean() {
        return new MessageDrivenBean();
    }

    /**
     * Create an instance of {@link ActivationConfigProperty}
     * 
     */
    public ActivationConfigProperty createActivationConfigProperty() {
        return new ActivationConfigProperty();
    }

    /**
     * Create an instance of {@link Relationships}
     * 
     */
    public Relationships createRelationships() {
        return new Relationships();
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link OpenejbJar}{@code >}} 
     * 
     */
    @XmlElementDecl(namespace = "http://openejb.apache.org/xml/ns/openejb-jar-2.2", name = "openejb-jar")
    public JAXBElement<OpenejbJar> createOpenejbJar(OpenejbJar value) {
        return new JAXBElement<OpenejbJar>(_OpenejbJar_QNAME, OpenejbJar.class, null, value);
    }

}
