/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.geronimo.jee.web;

import javax.xml.bind.JAXBElement;
import javax.xml.bind.annotation.XmlElementDecl;
import javax.xml.bind.annotation.XmlRegistry;
import javax.xml.namespace.QName;


/**
 * This object contains factory methods for each
 * Java content interface and Java element interface
 * generated in the <strong>org.apache.geronimo.jee.web</strong> package.
 * 
 * <p>An ObjectFactory allows you to programatically
 * construct new instances of the Java representation
 * for XML content. The Java representation of XML
 * content can consist of schema derived interfaces
 * and classes representing the binding of schema
 * type definitions, element declarations and model
 * groups.  Factory methods for each of these are
 * provided in this class.
 * 
 * @version $Rev: 642503 $ $Date: 2008-03-29 12:35:01 +0800 (Sat, 29 Mar 2008) $
 */
@XmlRegistry
public class ObjectFactory {

    private final static QName _WebApp_QNAME = new QName("http://geronimo.apache.org/xml/ns/j2ee/web-2.0.1", "web-app");

    /**
     * Create a new ObjectFactory that can be used to create new instances of schema 
     * derived classes for package: org.apache.geronimo.jee.web
     * 
     */
    public ObjectFactory() {
    }

    /**
     * Create an instance of {@link WebApp}
     * 
     */
    public WebApp createWebApp() {
        return new WebApp();
    }

    /**
     * Create an instance of {@link ContainerConfig}
     * 
     */
    public ContainerConfig createContainerConfig() {
        return new ContainerConfig();
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link WebApp}{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://geronimo.apache.org/xml/ns/j2ee/web-2.0.1", name = "web-app")
    public JAXBElement<WebApp> createWebApp(WebApp value) {
        return new JAXBElement<WebApp>(_WebApp_QNAME, WebApp.class, null, value);
    }

}
